searchNodes=[{"doc":"The Authentication plug for use with restricted routes. Would like to attribute much of this code to the phx_gen_auth package. https://github.com/aaronrenner/phx_gen_auth Thank you.","ref":"HubIdentityElixir.Authentication.html","title":"HubIdentityElixir.Authentication","type":"module"},{"doc":"Helper method to store the current_user in conn.assigns for easy use in views etc.","ref":"HubIdentityElixir.Authentication.html#fetch_current_user/2","title":"HubIdentityElixir.Authentication.fetch_current_user/2","type":"function"},{"doc":"Helper method to log in a user. This will store a user into the assign, as well as session under :current_user. Will redirect to &quot;/&quot;","ref":"HubIdentityElixir.Authentication.html#log_in_user/2","title":"HubIdentityElixir.Authentication.log_in_user/2","type":"function"},{"doc":"Logs the user out.It clears all session data for safety. See renew_session.","ref":"HubIdentityElixir.Authentication.html#log_out_user/1","title":"HubIdentityElixir.Authentication.log_out_user/1","type":"function"},{"doc":"Used for routes that require the user to be authenticated.If you want to enforce the user email is confirmed before they use the application at all, here would be a good place.","ref":"HubIdentityElixir.Authentication.html#require_authenticated_user/2","title":"HubIdentityElixir.Authentication.require_authenticated_user/2","type":"function"},{"doc":"An Elixir Package designed to make implementing HubIdentity authentication easy and fast. In order to use this package you need to have an account with HubIdentityCurrently this is only for Hivelocity uses. If you have a commercial interest please contact the Package Manager Erin Boeger through linkedIn or Github or through Hivelocity.","ref":"HubIdentityElixir.HubIdentity.html","title":"HubIdentityElixir.HubIdentity","type":"module"},{"doc":"Authenticate with HubIdentity using an email and password. This will call the HubIdentity server and try to autheniticate. Use this method for users who authenticate directly with HubIdentity. Upon successful email and passwordExamplesiex&gt; HubIdentityElixir.authenticate(%{email: &quot;erin@hivelocity.co.jp&quot;, password: &quot;password&quot;}) {:ok, %{&quot;access_token&quot; =&gt; access_token, &quot;refresh_token&quot; =&gt; refresh_token}} iex&gt; HubIdentityElixir.authenticate(%{email: &quot;erin@hivelocity.co.jp&quot;, password: &quot;wrong&quot;}) {:error, &quot;bad request&quot;}","ref":"HubIdentityElixir.HubIdentity.html#authenticate/1","title":"HubIdentityElixir.HubIdentity.authenticate/1","type":"function"},{"doc":"","ref":"HubIdentityElixir.HubIdentity.html#build_current_user/1","title":"HubIdentityElixir.HubIdentity.build_current_user/1","type":"function"},{"doc":"Get the current servers public key certificates. These certificates are used to verify a HubIdentity issued JWT signature. These certificates are rotated on a regular basis. If your website has significant activity, it may make sense to cache and refresh when they expire. Each certificate returned has a timestamp of when the certificate will expire.Examplesiex&gt; HubIdentityElixir.get_certs() [ { &quot;alg&quot;: &quot;RS256&quot;, &quot;e&quot;: &quot;AQAB&quot;, &quot;expires&quot;: 1614837416, &quot;kid&quot;: &quot;C8Rn3J8tPlMp8etztCsb4k51sjTFXbA-Til9XptF2FM&quot;, &quot;kty&quot;: &quot;RSA&quot;, &quot;n&quot;: &quot;really long n&quot;, &quot;use&quot;: &quot;sig&quot; }, ... ]","ref":"HubIdentityElixir.HubIdentity.html#get_certs/0","title":"HubIdentityElixir.HubIdentity.get_certs/0","type":"function"},{"doc":"Get a certificate by a kid. The kid is included with every HubIdentity issued JWT and idetnitifies which certificate was used to generate the certificate.Examplesiex&gt; HubIdentityElixir.get_certs(&quot;C8Rn3J8tPlMp8etztCsb4k51sjTFXbA-Til9XptF2FM&quot;) { &quot;alg&quot;: &quot;RS256&quot;, &quot;e&quot;: &quot;AQAB&quot;, &quot;expires&quot;: 1614837416, &quot;kid&quot;: &quot;C8Rn3J8tPlMp8etztCsb4k51sjTFXbA-Til9XptF2FM&quot;, &quot;kty&quot;: &quot;RSA&quot;, &quot;n&quot;: &quot;really long n&quot;, &quot;use&quot;: &quot;sig&quot; } iex&gt; HubIdentityElixir.get_certs(&quot;expired or not valid kid&quot;) nil","ref":"HubIdentityElixir.HubIdentity.html#get_certs/1","title":"HubIdentityElixir.HubIdentity.get_certs/1","type":"function"},{"doc":"Get the list of Open Authentication Providers from HubIdentity. Remember these links are only good once, and one link. If a users authenticates with Google then the facebook link will be invalid. The links also expire with 10 minutes of issue.Examplesiex&gt; HubIdentityElixir.get_providers() [ { &quot;logo_url&quot;: &quot;https://stage-identity.hubsynch.com/images/facebook.png&quot;, &quot;name&quot;: &quot;facebook&quot;, &quot;request_url&quot;: request_url } ]","ref":"HubIdentityElixir.HubIdentity.html#get_providers/0","title":"HubIdentityElixir.HubIdentity.get_providers/0","type":"function"},{"doc":"","ref":"HubIdentityElixir.HubIdentity.html#hub_identity_url/0","title":"HubIdentityElixir.HubIdentity.hub_identity_url/0","type":"function"},{"doc":"Parse and validate a JWT from HubIdentity. When successful will return an ok tuple with a current_user map.Examplesiex&gt; HubIdentityElixir.parse_token(%{&quot;access_token&quot; =&gt; access JWT}) {:ok, %{ owner_type: &quot;Hubsynch.User&quot;, owner_uid: &quot;uid_1234&quot;, uid: &quot;hub_identity_uid_1234&quot;, user_type: &quot;HubIdentity.User&quot; } } iex&gt; HubIdentityElixir.parse_token(%{&quot;access_token&quot; =&gt; invalid JWT}) {:error, :claims_parse_fail}","ref":"HubIdentityElixir.HubIdentity.html#parse_token/1","title":"HubIdentityElixir.HubIdentity.parse_token/1","type":"function"},{"doc":"Module with named helpers generated from HubIdentityElixir.Phoenix.Router.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html","title":"HubIdentityElixir.Phoenix.Router.Helpers","type":"module"},{"doc":"Generates the path information including any necessary prefix.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html#path/2","title":"HubIdentityElixir.Phoenix.Router.Helpers.path/2","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html#static_integrity/2","title":"HubIdentityElixir.Phoenix.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html#static_path/2","title":"HubIdentityElixir.Phoenix.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html#static_url/2","title":"HubIdentityElixir.Phoenix.Router.Helpers.static_url/2","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"HubIdentityElixir.Phoenix.Router.Helpers.html#url/1","title":"HubIdentityElixir.Phoenix.Router.Helpers.url/1","type":"function"},{"doc":"HubIdentityElixirAn Elixir Package designed to make implementing HubIdentity authentication easy and fast. In order to use this package you need to have an account with HubIdentityCurrently this is only for Hivelocity uses. If you have a commercial interest please contact the Package Manager Erin Boeger through linkedIn or Github or through Hivelocity.","ref":"readme.html","title":"HubIdentityElixir","type":"extras"},{"doc":"The package can be installed by adding hub_identity_elixir to your list of dependencies in mix.exs:def deps do [ {:hub_identity_elixir, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"HubIdentityElixir - Installation","type":"extras"},{"doc":"Setup your configuration in config.exs, dev.exs, prod.exs etc:config :hub_identity_elixir, :url, # Either staging, production, or localhost config :hub_identity_elixir, :public_key, # The public key from HubIdentity config :hub_identity_elixir, :otp_app, # The name of your OTP applicationInside your Router add use HubIdentityElixir.Phoenix.Router and include the hub_identity_routes()in router.exs:defmodule MyAppWeb.Router do use MyAppWeb, :router use HubIdentityElixir.Phoenix.Router # &lt;- Add HubIdentity Router # router stuff.. scope &quot;/&quot;, MyAppWeb do pipe_through :browser hub_identity_routes() # &lt;- Add HubIdentity routes get &quot;/&quot;, PageController, :index endThis will add the following routes to your application:session_path DELETE /sessions/logout HubIdentityElixir.Phoenix.SessionController :deletesession_path GET /sessions/new HubIdentityElixir.Phoenix.SessionController :newsession_path GET /sessions/create HubIdentityElixir.Phoenix.SessionController :createIf you want a @current_user helper then add plug :fetch_current_user to your pipeline.","ref":"readme.html#setup","title":"HubIdentityElixir - Setup","type":"extras"},{"doc":"For authentication required (restricted) routes add the plug require_authenticated_user for example:scope &quot;/&quot;, MyAppWeb do pipe_through [:browser, :require_authenticated_user] get &quot;/something/restricted&quot;, PageController, :something get &quot;/something_else/restricted&quot;, PageController, :something_else end","ref":"readme.html#restricted-routes","title":"HubIdentityElixir - Restricted routes","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs at hub_identity_elixir","ref":"readme.html#documentation","title":"HubIdentityElixir - Documentation","type":"extras"}]